#pragma once

#define SEVENZIP_ERR_OK 0
#define SEVENZIP_ERR_WARNINGS 1
#define SEVENZIP_ERR_FATAL 2
#define SEVENZIP_ERR_CMDLINE 7
#define SEVENZIP_ERR_OUTOFMEMORY 8
#define SEVENZIP_ERR_ABORTED 255

static const UINT WM_ARC_PROGRESS = ::RegisterWindowMessage(TEXT("SEVENZIP_ARC_PROGRESS"));

#define SEVENZIP_PROGRESSINFO_PERCENT_DONE 1
#define SEVENZIP_PROGRESSINFO_CURRENT_ARCHIVE 2
#define SEVENZIP_PROGRESSINFO_CURRENT_FILE 3

#define SEVENZIP_CANT_FIND_FILE 1
#define SEVENZIP_UPDATE_FAILURE 2

struct SEVENZIP_ARC_PROGESS
{
	int infoType;
	void *content;
};

struct SEVENZIP_FILE_INFO
{
	TCHAR *name;
	bool isDir;
	bool isEncrypted;
	unsigned __int64 size;
	unsigned __int64 packedSize;
	FILETIME modifiedTime;
};

struct SEVENZIP_FAILURE_INFO
{
	TCHAR *name;
	int cause;
	HRESULT failureCode;
};

typedef bool CALLBACK SEVENZIP_PROGRESS_PROC(SEVENZIP_ARC_PROGESS *progressInfo, void *userData);

extern "C" int __declspec(dllexport) SevenzipCmdExec(LPTSTR baseDir, LPTSTR cmd);
extern "C" void __declspec(dllexport) SevenzipSetCallback(SEVENZIP_PROGRESS_PROC *progressCallback, void *userData);
extern "C" unsigned __int32 __declspec(dllexport) SevenzipGetNumFiles();
extern "C" SEVENZIP_FILE_INFO __declspec(dllexport) *SevenzipGetFileInfo(unsigned __int32 index);
extern "C" __int32 __declspec(dllexport) SevenzipGetNumFailures();
extern "C" SEVENZIP_FAILURE_INFO __declspec(dllexport) *SevenzipGetFailureInfo(__int32 index);
extern "C" bool __declspec(dllexport) SevenzipHasEncryptedHeader();
extern "C" void __declspec(dllexport) SevenzipClearFileInfo();
extern "C" void __declspec(dllexport) SevenzipClearFailureInfo();
extern "C" LPTSTR __declspec(dllexport) SevenzipGetLastErrorMsg();


