#pragma once

#include "StdAfx.h"

#include "Ez7Zip.h"

#include "Common/MyInitGuid.h"

#include "Common/CommandLineParser.h"
#include "Common/MyException.h"
#include "Common/IntToString.h"
#include "Common/StdOutStream.h"
#include "Common/StringConvert.h"
#include "Common/StringToInt.h"

#include "Windows/FileDir.h"
#include "Windows/FileName.h"
#include "Windows/Defs.h"
#include "Windows/Error.h"
#include "Windows/MemoryLock.h"

#include "../../IPassword.h"
#include "../../ICoder.h"
#include "../../UI/Common/UpdateAction.h"
#include "../../UI/Common/Update.h"
#include "../../UI/Common/Extract.h"
#include "../../UI/Common/ArchiveCommandLine.h"
#include "../../UI/Common/ExitCode.h"

//#include "../../Compress/LZMA_Alone/LzmaBenchCon.h"

#include "ListDll.h"
#include "OpenCallbackDll.h"
#include "ExtractCallbackDll.h"
#include "UpdateCallbackDll.h"

#include "../../MyVersion.h"

#if defined( _WIN32) && defined( _7ZIP_LARGE_PAGES)
extern "C"
{
#include "../../../../C/Alloc.h"
}
#endif

using namespace NWindows;
using namespace NFile;
using namespace NCommandLineParser;

class CMyArchiveHandler
{
public:
	CMyArchiveHandler(void);
	virtual ~CMyArchiveHandler(void);
	
	int CmdExec(LPCTSTR baseDir, LPCTSTR cmdLine);
	//int ReadArchiveContent(LPCTSTR archivePath, LPCTSTR password);
	UInt32 GetNumFiles();
	SEVENZIP_FILE_INFO *GetFileInfo(UInt32 index);
	bool HasEncryptedHeader();

	int GetNumFailures();
	SEVENZIP_FAILURE_INFO *GetFailureInfo(int index);
	
	void SetCallback(SEVENZIP_PROGRESS_PROC *progressCallback, void *userData);
	void ClearFileInfo();
	void ClearFailureInfo();
	LPTSTR GetLastErrorMsg();
	
private:
	SEVENZIP_PROGRESS_PROC *m_ProgressCallback;
	void *m_UserData;
	
	int Execute(LPCTSTR baseDir, LPCTSTR cmdLine);

	bool GetBoolValue(IInArchive *archive, UInt32 index, PROPID propID, bool &value);
	bool GetUInt64Value(IInArchive *archive, UInt32 index, PROPID propID, UInt64 &value);
	bool GetFileTime(IInArchive *archive, UInt32 index, PROPID propID, FILETIME &value);


	//int ReadContent(LPCTSTR archivePath, LPCTSTR password);
	SEVENZIP_FILE_INFO *m_FileInfo;
	UInt32 m_NumFileInfo;
	bool m_EncryptedHeader;
	
  CRecordVector<SEVENZIP_FAILURE_INFO> m_Failures;

	LPTSTR m_LastErrorMsg;

	HRESULT ListArchives(CCodecs *codecs, const CIntVector &formatIndices,
    UStringVector &archivePaths, UStringVector &archivePathsFull,
    const NWildcard::CCensorNode &wildcardCensor,
    bool &passwordEnabled, UString &password,
    UInt64 &numErrors);
};
